#include "agent.h"
#include "rtProtoHBH.h"

int hdr_HBH::offset_;

static class rtHBHHeaderClass : public PacketHeaderClass {
public:
	rtHBHHeaderClass() : PacketHeaderClass("PacketHeader/rtProtoHBH",
					      sizeof(hdr_HBH)) {
		bind_offset(&hdr_HBH::offset_);
	} 
} class_rtProtoHBH_hdr;

static class rtProtoHBHclass : public TclClass {
public:
	rtProtoHBHclass() : TclClass("Agent/HBH") {}
	TclObject* create(int, const char*const*) {
		return (new rtProtoHBH);
	}
} class_rtProtoHBH;


int rtProtoHBH::command(int argc, const char*const* argv)
{
	/*
	 * send-control $dst-addr $dst-port $mtype $size
	 *
	 */
	if (strcmp(argv[1], "send-control") == 0) {
	  //printf("entrou em send-control\n");
		ns_addr_t dst;
		dst.addr_ = atoi(argv[2]);
		dst.port_ = atoi(argv[3]);
		u_int32_t mtype = atoi(argv[4]);
		u_int32_t size  = atoi(argv[5]);
		sendpkt(dst, mtype, size);
		return TCL_OK;
	}
	//printf("merda");
	return Agent::command(argc, argv);
}

void rtProtoHBH::sendpkt(ns_addr_t dst, u_int32_t mtype, u_int32_t size)
{
	daddr() = dst.addr_;
	dport() = dst.port_;
	size_ = size;
	
	Packet* p = Agent::allocpkt();
	hdr_HBH *rh = (hdr_HBH*)p->access(off_HBH_);
	rh->message_type() = mtype;

	target_->recv(p);
}

void rtProtoHBH::recv(Packet* p, Handler*)
{
	hdr_HBH* rh = (hdr_HBH*)p->access(off_HBH_);
	hdr_ip* ih = (hdr_ip*)p->access(off_ip_);
	Tcl::instance().evalf("%s recv-control %d %d", name(),
			      ih->saddr(), rh->message_type());
	Packet::free(p);
}
