#include "agent.h"
#include "rtProtoREU.h"

int hdr_REU::offset_;

static class rtREUHeaderClass : public PacketHeaderClass {
public:
	rtREUHeaderClass() : PacketHeaderClass("PacketHeader/rtProtoREU",
					      sizeof(hdr_REU)) {
		bind_offset(&hdr_REU::offset_);
	} 
} class_rtProtoREU_hdr;

static class rtProtoREUclass : public TclClass {
public:
	rtProtoREUclass() : TclClass("Agent/REU") {}
	TclObject* create(int, const char*const*) {
		return (new rtProtoREU);
	}
} class_rtProtoREU;


int rtProtoREU::command(int argc, const char*const* argv)
{
	/*
	 * send-control $dst-addr $dst-port $mtype $size
	 *
	 */
	if (strcmp(argv[1], "send-control") == 0) {
	  //printf("entrou em send-control\n");
		ns_addr_t dst;
		dst.addr_ = atoi(argv[2]);
		dst.port_ = atoi(argv[3]);
		u_int32_t mtype = atoi(argv[4]);
		u_int32_t size  = atoi(argv[5]);
		sendpkt(dst, mtype, size);
		return TCL_OK;
	}
	//printf("merda");
	return Agent::command(argc, argv);
}

void rtProtoREU::sendpkt(ns_addr_t dst, u_int32_t mtype, u_int32_t size)
{
	daddr() = dst.addr_;
	dport() = dst.port_;
	size_ = size;
	
	Packet* p = Agent::allocpkt();
	hdr_REU *rh = (hdr_REU*)p->access(off_REU_);
	rh->message_type() = mtype;

	target_->recv(p);
}

void rtProtoREU::recv(Packet* p, Handler*)
{
	hdr_REU* rh = (hdr_REU*)p->access(off_REU_);
	hdr_ip* ih = (hdr_ip*)p->access(off_ip_);
	Tcl::instance().evalf("%s recv-control %d %d", name(),
			      ih->saddr(), rh->message_type());
	Packet::free(p);
}
