#include "agent.h"
#include "rtProtoSMM-LS.h"
#include "SourceRtg.h"

int hdr_SMM_LS::offset_;

static class rtSMM_LSHeaderClass : public PacketHeaderClass {
public:
  rtSMM_LSHeaderClass() : PacketHeaderClass("PacketHeader/rtProtoSMM_LS",
					 sizeof(hdr_SMM_LS)) {
    bind_offset(&hdr_SMM_LS::offset_);
  } 
} class_rtProtoSMM_LS_hdr;

static class rtProtoSMM_LSclass : public TclClass {
public:
  rtProtoSMM_LSclass() : TclClass("Agent/rtProto/SMM_LS") {}
  TclObject* create(int, const char*const*) {
    return (new rtProtoSMM_LS);
  }
} class_rtProtoSMM_LS;

int rtProtoSMM_LS::command(int argc, const char*const* argv)
{
  if (strcmp(argv[1], "send-update") == 0) {
    ns_addr_t  dst;
    dst.addr_ = atoi(argv[2]);
    dst.port_ = atoi(argv[3]);;
    u_int32_t mtvar = atoi(argv[4]);
    u_int32_t size  = atoi(argv[5]);
    sendpkt(dst, mtvar, size);
    return TCL_OK;
  }
  return Agent::command(argc, argv);
}

void rtProtoSMM_LS::sendpkt(ns_addr_t dst, u_int32_t mtvar, u_int32_t size)
{
  //dst_ = dst;
        daddr() = dst.addr_;
        dport() = dst.port_;                                                    
  size_ = size;
  
  Packet* p = Agent::allocpkt();
  hdr_SMM_LS *rh = (hdr_SMM_LS*)p->access(off_SMM_LS_);  //por enquanto, pacote DV
  rh->metricsVar() = mtvar;
  
  hdr_ip *hip = (hdr_ip*)p->access(off_ip_);
  hip->fid_ = 0x0000FFFF;
  //luish: by now we use this flow id to avoid dropping routing packets

hdr_src_rtg* srt = hdr_src_rtg::access(p);  // luish - rever lixo 
   //srt->srcflag() = 0;
  
  target_->recv(p);
}

void rtProtoSMM_LS::recv(Packet* p, Handler*)
{
  hdr_SMM_LS* rh = (hdr_SMM_LS*)p->access(off_SMM_LS_);
  hdr_ip* ih = (hdr_ip*)p->access(off_ip_);
  Tcl::instance().evalf("%s recv-update %d %d", name(),
			ih->saddr(), rh->metricsVar());
  Packet::free(p);
}

//luish - arquivo para criar a classe rtProtoSMM_LS
