#include "agent.h"
#include "rtProtoSMM.h"       //rever!!!

int hdr_SMM::offset_;

static class rtSMMHeaderClass : public PacketHeaderClass {
public:
  rtSMMHeaderClass() : PacketHeaderClass("PacketHeader/rtProtoSMM",
					 sizeof(hdr_SMM)) {
    bind_offset(&hdr_SMM::offset_);
  } 
} class_rtProtoSMM_hdr;

static class rtProtoSMMclass : public TclClass {
public:
  rtProtoSMMclass() : TclClass("Agent/rtProto/SMM") {}
  TclObject* create(int, const char*const*) {
    return (new rtProtoSMM);
  }
} class_rtProtoSMM;

int rtProtoSMM::command(int argc, const char*const* argv)
{
  if (strcmp(argv[1], "send-update") == 0) {
    ns_addr_t  dst;
    dst.addr_ = atoi(argv[2]);
    dst.port_ = 0; 
    u_int32_t mtvar = atoi(argv[3]);
    u_int32_t size  = atoi(argv[4]);
    sendpkt(dst, mtvar, size);
    return TCL_OK;
  }
  return Agent::command(argc, argv);
}

void rtProtoSMM::sendpkt(ns_addr_t dst, u_int32_t mtvar, u_int32_t size)
{
//  dst_ = dst;
  daddr() = dst.addr_;
  dport() = dst.port_;                                                    
  size_ = size;
  
  Packet* p = Agent::allocpkt();
  hdr_SMM *rh = (hdr_SMM*)p->access(off_SMM_);  //por enquanto, pacote DV
  rh->metricsVar() = mtvar;
  
  hdr_ip *hip = (hdr_ip*)p->access(off_ip_);
  hip->fid_ = 0x0000FFFF;
  //luish: by now we use this flow id to avoid dropping routing packets
  
  target_->recv(p);
}

void rtProtoSMM::recv(Packet* p, Handler*)
{
  hdr_SMM* rh = (hdr_SMM*)p->access(off_SMM_);
  hdr_ip* ih = (hdr_ip*)p->access(off_ip_);
  Tcl::instance().evalf("%s recv-update %d %d", name(),
			ih->saddr(), rh->metricsVar());
  Packet::free(p);
}

//luish - arquivo para criar a classe rtProtoSMM
