## 
## File:    usage.gpl (gnuplot script)
## Author:  Pascal ANELLI
## Created: 07/99
## Purpose: plot bandwidth % in function of load
## 
## data files are in local directory

#
#   set environment
#
#set term postscript landscape
#set terminal postscript eps  "Helvetica" 18 
#set term x11
#set term latex

set term `echo $GNUPLOT_TERM`

#
#   compose plot
#
set data style lines
set title `echo $GNUPLOT_TITLE`
set xlabel  'rho 1'
set ylabel  'bandwidth (%)'


#set xrange [0:1]
set yrange [0:11]
set xtics  0, 0.1, 1
set ytics 0,2,10
set grid

#  average throughtput by class by micro flow
plot "sumTP.data" using 4:5 title "flow IN (1)" with lines,\
     "sumTP.data" using 4:12 title "flow OUT (2)" with lines
pause -1

#  min and max throughtput by class by micro flow
plot "sumTP.data" using 4:6 title "min flow IN (1)" with lines,\
     "sumTP.data" using 4:7 title "max flow IN (1)" with lines,\
     "sumTP.data" using 4:13 title "min flow OUT (2)" with lines,\
     "sumTP.data" using 4:14 title "max flow OUT (2)" with lines
     
pause -1


set yrange [0:90]
set ytics 0,10,90

plot "sumTP.data" using 4:20 title "aggregate flow IN (1)" with lines,\
     "sumTP.data" using 4:21 title "aggregate flow OUT (2)" with lines

pause -1


