#!/bin/bash
#
# Copyright (c) 1999 The University of Paris VI
# All rights reserved.
# 
# Permission to use and copy this software in source and binary forms
# is hereby granted, provided that the above copyright notice, this
# paragraph and the following disclaimer are retained in any copies
# of any part of this software and that the University of Paris VI is
# acknowledged in all documentation pertaining to any such copy
# or derivative work. The name of the University of Paris VI may not
# be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL 
# THE UNIVERSITY OF PARIS VI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
# SOFTWARE.
#
# Contributed by the RP Research Group, http://www.lip6.fr/rp
#
#  usage:
#         aftersimul r phi1 rho  [<data file>] [<psfile>]

if [ $# \< 3 ]; then
	echo "usage aftersimul r phi1 rho  [<data file>] [<psfile>]"
	exit 0	
fi

if [ $# = 5 ]; then
	export GNUPLOT_TERM="post landscape mono \"Times-Roman\" 12"
	psfile="$5"
	echo Output on $psfile...
else    
	export GNUPLOT_TERM="x11"
	echo Output is x11.
fi


if [ $# \> 3 ]; then
	if [ -r sumTP.data ]; then
		rm sumTP.data
	fi
	ln -s $4 sumTP.data
fi

export GNUPLOT_TITLE="\"Offered throughput, r= $1, rho: $3, phi(1): $2\""

gnuplot /home/diffserv/ns-2/tcl/airs/aftersimul.gp 

# psnup -n2 /tmp/direct.ps > /tmp/direct2.ps

