#
# Copyright (c) 1998 The University of Paris VI
# All rights reserved.
# 
# Permission to use and copy this software in source and binary forms
# is hereby granted, provided that the above copyright notice, this
# paragraph and the following disclaimer are retained in any copies
# of any part of this software and that the University of Paris VI is
# acknowledged in all documentation pertaining to any such copy
# or derivative work. The name of the University of Paris VI may not
# be used to endorse or promote products derived from this software
# without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
# EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE WARRANTIES OF 
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT SHALL 
# THE UNIVERSITY OF PARIS VI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
# SOFTWARE.
#
# Contributed by the RP Research Group, http://www.lip6.fr/rp
#


Queue/WFQ set num_classes_ 0
Queue/PQCM set delta_ 0.1

Simulator instproc install-phb { n1 n2 phb {ifqType Queue/DropTail} weight } {

	$self simplex-install-phb  $n1 $n2 $phb $ifqType  $weight
	$self simplex-install-phb  $n2 $n1 $phb $ifqType  $weight
 }


Simulator instproc simplex-install-phb { n1 n2 codepoint {ifqType Queue/DropTail} weight } {

	set link [$self link $n1 $n2]
	set schedul [$link queue]

	$schedul instvar queue_
	set queue_($codepoint) [new $ifqType]
	
	$schedul install $codepoint $queue_($codepoint) $weight
 }
 

Simulator instproc add-codepoint { n1 n2 codepoint newcodepoint } {

	$self simplex-add-codepoint  $n1 $n2 $codepoint $newcodepoint 
	$self simplex-add-codepoint  $n2 $n1 $codepoint $newcodepoint 
 }


Simulator instproc simplex-add-codepoint { n1 n2 codepoint newcodepoint } {

	set link [$self link $n1 $n2]
	set schedul [$link queue]	
	
	$schedul bind $codepoint $newcodepoint
 }
