#--------------------------------------------------------------
#
#                        AWK Code
#
#--------------------------------------------------------------


#--------------------------------------------------------------------------

# awk code used to produce:
#      x axis: time
#      y axis: rate by class
 set awk_rate {
            BEGIN { new = 1;
            	    prev= 0
            	  }
             $1 > 0 {
                class = $1;
                time = $2;
                bytes = $3;
                interval = $4
                
                if (class != prev) {
                        prev = class;
                        print "\n\n";
                }
                

                if (interval > 0) {
                    bitsPerSecond = 8*bytes/interval;
                    print time, 100*bitsPerSecond/bandwidth;
                }
            }
        }

#  Code used to compute the average rate for each class
#      one column for each class 
 set awk_rate_avg {
            BEGIN { OFS ="\t"

		for (i=1; i<=2 ; i++) {
			 sum[i*16^6] = 0; 
			 min_time[i*16^6] = 10*startt;
			 max_time[i*16^6] = 0;
		}      
            }
            
	    $2 >= startt {

                class = $1;
                time = $2;
                bytes = $3;
                interval = $4

                if (time > max_time[class]) 
                	max_time[class] = time;	
                
                if (time < min_time[class]) 
		    	min_time[class] = time;
		
		sum[class] += bytes
		
            }
            
            END {
                
		for (i=1; i<=2 ; i++) {
			class = i*16^6;
			 msmttime = max_time[class] - min_time[class]
			 if (msmttime == 0)
			 	rate = 0;
			 else
			 	rate = (100*8*sum[class])/(msmttime*bandwidth);
			 printf "%f ", rate;
		}
                printf "\n"
            }
}
